#!/usr/bin/env perl
 
# This takes a short string of text an spits out an mp3 audio
# file of it being spoken. This can then be converted for use
# in asterisk in the native sln16 format. 
 
use LWP;
 
$speak = $ARGV[0];
if (length($speak) ==0 || length($speak) > 100) { die ('String is too long'); }
 
my @headers1 = (
'Host' => 'translate.google.com',
'User-Agent' => 'Mozilla/5.0 (X11; U; Linux x86_64; en-US; rv:1.9.1.5) Gecko/20111114 Ubuntu/9.10 (karmic) Firefox/8.0.1',
'Accept' => 'text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8',
'Accept-Language' => 'en-us,en;q=0.5',
'Accept-Encoding' => 'gzip,deflate',
'Accept-Charset' => 'ISO-8859-1,utf-8;q=0.7,*;q=0.7',
'Keep-Alive' => '300',
'Connection' => 'keep-alive',
);
 
my $browser = LWP::UserAgent->new;
 
$speak =~ s/ /+/g;
 
$sec = time();
$resp = $browser->get("http://translate.google.com/translate_tts?q=$speak",@headers1);
 
open(FILE,">$sec.mp3");
print FILE $resp->content;
close(FILE);
print "Wrote $sec.mp3\n";
 
# To convert for asterisk use
# sox <file.mp3> -t raw outfile.sln16
